unit editrect;

(* ------------------------------------------------------------------------ *)
(* !                         Public part                                  ! *)
(* ------------------------------------------------------------------------ *)

interface

const
     taillemax=20;  (* des matrices *)
     path='c:\tmp\';
     profndr=10;      (* niveau maximal de fractalisation *)

type
  matrice=array[0..taillemax,1..taillemax] of real;
  (* [0,1]=nbre de lignes   [0,2]=nbre de colonnes *)
  listenoeuds = array [1..taillemax] of string;
  matriceptr=^matrice;
  liste=array[1..profndr] of real;

var
   n:integer;
   key:char;
   m,classe:matriceptr;
   noms:listenoeuds;
   compteur,posactu:liste;

procedure editor;
procedure savegraphe;

(* ------------------------------------------------------------------------ *)
(* !                         Private part                                 ! *)
(* ------------------------------------------------------------------------ *)

implementation

uses crt;

type
  graphe = record
         mat: matrice;
         noeuds:  listenoeuds;
  end;
  graphefile = file of graphe;

(* ------------------------------------------------------------------------ *)
(* !                       Variables globales                             ! *)
(* ------------------------------------------------------------------------ *)

var
   keyk:char;

(* ------------------------------------------------------------------------ *)
(* !                     Fonctions et procdures                          ! *)
(* ------------------------------------------------------------------------ *)


procedure entrenoeuds;
var
   i:integer;
begin
     clrscr;
     writeln(' Enter the name of the nodes please.');
     for i:=1 to n do begin
         writeln('');
         write(' ',i,'th node : ');
         readln(noms[i]);
     end;
     writeln('');
     writeln('');
end;


                        (* .................. *)

procedure noeuddejavu(var noeud:string);
var
   i,nb,w:integer;
   debut:string;
   noeudstrouves:listenoeuds;
begin
     for i:=1 to n do if noeud=noms[i] then exit;
     nb:=0;
     debut:=noeud;
     if length(debut) > 3 then delete(debut,4,length(debut)-3);
     for i:=1 to n do begin
         if pos(debut,noms[i]) <> 0 then begin
              nb:=nb+1;
              noeudstrouves[nb]:=noms[i];
         end;
     end;
     if nb <> 0 then begin
        writeln('Is this node among the following nodes ? (Y/N)');
        for i:=1 to nb do write(noeudstrouves[i],'     ');
        key:=readkey;
        if (key='y')or(key='Y')then begin
           writeln('');
           write('Enter the chosen node :');
           readln(noeud);
           for i:=1 to nb do if noeud=noeudstrouves[i] then w:=3;
           if w <> 3 then begin
              writeln;
              writeln('Unknown node !');
              noeud:='bozork';
           end;
        end
        else begin
           writeln;
           writeln('Unknown node !');
           noeud:='bozork';
        end;
     end
     else begin
        writeln;
        writeln('Unknown node !');
        noeud:='bozork';
     end;
end;


                        (* .................. *)

procedure nouveauxliens(sym:char;noeud:string);
var
   noeudlie:string;
   i,k,index:integer;
begin
     for i:=1 to n do if noms[i]=noeud then index:=i;
     repeat
           write('Link with ',noeud,'   : ');
           readln(noeudlie);
           if noeudlie='' then exit;
           noeuddejavu(noeudlie);
           if noeudlie<>'bozork' then begin for i:=1 to n do if noeudlie=noms[i] then k:=i;
                                            write('       Weight of the link between ',noeud,' and ',noeudlie,'  : ');
                                            readln(m^[index,k]);
                                            if (sym='Y')or(sym='y') then m^[k,index]:=m^[index,k];
           end;
     until false;
end;


                        (* .................. *)

procedure nouveaugraphe;
var
   i,j:integer;
begin
     clrscr;
     writeln('Number of nodes : ');
     readln(n);
     for i:=1 to n do for j:=1 to n do m^[i,j]:=0;
     entrenoeuds;
     writeln('');
     repeat writeln('Do you want the arcs to be symetric ? (Y/N)');
            key:=readkey;
     until (key='Y')or(key='y')or(key='N')or(key='n');
     writeln(key);
     for i:=1 to n do begin
         writeln('');
         writeln('');
         writeln('Now enter the arcs associated with node ',noms[i],' please.');
         nouveauxliens(key,noms[i]);
     end;
     writeln;
end;


                        (* .................. *)

procedure savegraphe;
var
   gf:graphefile;
   g:graphe;
   nom:string;
begin
     m^[0,1]:=n;
     m^[0,2]:=n;
     g.mat:=m^;
     g.noeuds:=noms;
     writeln('');
     writeln('Name of the graph : ');
     write('      ');
     readln(nom);
     nom:=path+nom+'.gra';
     assign(gf,nom);
     rewrite(gf);
     write(gf,g);
     close(gf);
     writeln('graph saved as ',nom);
     key:=readkey;
end;

                        (* .................. *)

procedure loadgraphe;
var
   gf:graphefile;
   g:graphe;
   nom:string;
begin
     writeln('');
     writeln('Name of the graph to load : ');
     write('      ');
     readln(nom);
     nom:=path+nom+'.gra';
     writeln ('name : ',nom);
     assign(gf,nom);
     reset(gf);
     read(gf,g);
     close(gf);
     noms:=g.noeuds;
     m^:=g.mat;
     writeln(' Graph ',nom,' loaded.');
     key:=readkey;
     n:=round(m^[0,1]);
end;


                        (* .................. *)

procedure modifnoms;
var
   i,j,numero,code:integer;
   numerostr:string;
begin
     repeat
           writeln ('Current names :');
           if n<20 then for i:=1 to n do writeln(i,'-   ',noms[i]);
           for j:=1 to n div 20 do begin
               for i:=1+(j-1)*n to n*j do writeln(i,'-   ',noms[i]);
               key:=readkey;
           end;
           writeln('Number of the node to modify (RETURN to quit, 0 to see again) :');
           readln(numerostr);
           if numerostr='' then exit;
           if numerostr<>'0' then begin
               val(numerostr,numero,code);
               writeln('');
               writeln(' Current name of the ',numero,'th node :',noms[numero]);
               write('New name (RETURN to cancel): ');
               readln(numerostr);
               if numerostr<>'' then noms[numero]:=numerostr;
           end;
     until false;
end;


                        (* .................. *)

procedure modifliens;
var
   i,nb,numero,j,code:integer;
   numerostr,answer:string;
   label 1;
begin
     repeat
           1: writeln ('Choose the node to modify :');
           if n<20 then for i:=1 to n do writeln(i,'-   ',noms[i])
           else for j:=1 to n div 20 do begin
                    for i:=1+(j-1)*n to n*j do writeln(i,'-   ',noms[i]);
                    key:=readkey;
                end;
           writeln('Number of the node to modify (RETURN to quit, 0 to see again) :');
           readln(numerostr);
           if numerostr='' then exit;
           if numerostr<>'0' then begin
               val(numerostr,numero,code);
               clrscr;
               repeat
                     writeln('Here are the nodes linked with ',noms[numero],' and the weight of these arcs');
                     if n<20 then
                        for i:=1 to n do
                            if (i <> numero)and(m^[i,numero]<>0) then writeln(i,'-   ',noms[i],'      =>  ',m^[i,numero])
                     else for j:=1 to n div 20 do begin
                            for i:=1+(j-1)*n to n*j do
                                if (i<>numero)and(m^[i,numero]<>0) then writeln(i,'-   ',noms[i],'     =>  ',m^[i,numero]);
                            key:=readkey;
                          end;
                     writeln('Enter the number of the link to modify');
                     writeln(' (RETURN to quit, N to deal with another node, 0 to check the arcs)');
                     readln(answer);
                     if answer='' then exit;
                     if (answer='n')or(answer='N') then goto 1;
                     if (answer<>'0')and(answer<>numerostr) then begin
                          val(answer,nb,code);
                          writeln('');
                          writeln('Arc from ',noms[numero],' to ',noms[nb]);
                          writeln(' current value : ',m^[numero,nb]);
                          write('New value :  ');
                          readln(m^[numero,nb]);
                          writeln('Make symetric ? (Y/N)');
                          key:=readkey;
                          if (key='y')or(key='Y') then m^[nb,numero]:=m^[numero,nb];
                     end;
               until false;
           end;
     until false;
end;


                        (* .................. *)

procedure modifgraphe;
begin
     repeat
           clrscr;
           writeln('Modify the (N)ames of the nodes or the (L)inks between nodes ?');
           writeln('(RETURN) to modify nothing');
           key:=readkey;
           writeln(key);
     until (key='N')or(key='n')or(key='L')or(key='l')or(key=chr(13));
     if key=chr(13) then exit;
     if (key='N')or(key='n') then modifnoms
     else modifliens;
end;


                        (* .................. *)

procedure classement;
          (* classe^[i,j] est l'ordre qu'occupe, pour le noeud i, le noeud *)
          (* j dans un classement dcroissant en fonction de la force du *)
          (* lien entre i et j, soit m^[i,j] *)
var
   tester:listenoeuds;
   i,j,k,l: integer;  (* tester est nul si j n'a pas deja ete *)
   maxi: real;               (* classe pour i *)
begin
     classe^[0,1]:=n;
     classe^[0,2]:=n;
     for i:=1 to n do begin
         maxi:=10000;
         for j:=1 to n do tester[j]:='non';
         for j:=1 to n do begin
             l:=0;
             repeat begin l:=l+1; classe^[i,j]:=l; end until tester[l]='non';
             for k:=1 to n do begin
                 if (tester[k]='non') and (m^[i,k]>=m^[i,round(classe^[i,j])]) and (m^[i,k]<=maxi)
                                   then classe^[i,j]:=k;
             end;
             maxi:=m^[i,round(classe^[i,j])];
             tester[round(classe^[i,j])]:='oui';
         end;
     end;
end;


                        (* .................. *)

procedure editor;
var
   z:integer;
begin
     z:=0;
     repeat
           repeat begin
                       clrscr;
                       writeln('(N)ew graph');
                       writeln('(M)odify or load a graph in ',path);
                       writeln('(C)ontinue');
                       keyk:=readkey;
                       writeln(keyk);
                  end;
           until (keyk='N')or(keyk='n')or(keyk='M')or(keyk='m')or(keyk='C')or(keyk='c');
           if (keyk='N')or(keyk='n') then begin
                                             z:=2;
                                             nouveaugraphe;
                                             writeln(' Save in ',path,' ? (Y/N)');
                                             key:=readkey;
                                             if (key='Y')or(key='y') then savegraphe;
                                        end;
           if (keyk='M')or(keyk='m') then begin
                                             z:=2;
                                             loadgraphe;
                                             modifgraphe;
                                             if key <> chr(13) then begin
                                                writeln(' Save modifications in ',path,' ? (Y/N)');
                                                key:=readkey;
                                                if (key='Y')or(key='y') then savegraphe;
                                             end;
                                        end;
     until ((keyk='c')or(keyk='C'))and(z=2);
     classement;
end;
end.