program fracrec3;


(* ---------------------------------------------------------------------- *)
(* !                        Initialisation                              ! *)
(* ---------------------------------------------------------------------- *)


uses crt,graph,drivers,objects,editrect;

const
     epsilon=0.001;
     pxl=5;       (* degr de dfinition maximale *)
     pi=3.14159;     (* ! *)
(*     profmax=25;     (* longueur maximale des listes !!! n !!! *)
     hauteur=450;        (* hauteur de l'cran en pixels *)
     largeur=450;       (* largeur de l'cran en pixels *)
     rect: array[1..4] of PointType = ((X:  490; Y: 65 ),
   (X: 600; Y: 65), (X:600; Y: 70+profndr*20),(X: 490; Y: 110+profndr*20));
     taille=32;
     coefz=80000;
     coeflis=0.05;

type
    listbis=array[1..profndr] of real;
    listtot=array[1..taillemax] of real;
    complexe=array[1..2] of real;
    arraytot=array[1..taillemax,1..profndr] of real;
    triangle=array[1..10] of integer;
    tablo=array[1..taille,1..taille] of real;
    tablalo=array[1..3*taille,1..3*taille] of real;
    tablaloptr=^tablalo;

var
   brut:array[1..taille,1..taille] of integer;
   final:tablo;
   compt:integer;

(* ---------------------------------------------------------------------- *)
(* !                      Procdures et fonctions                       ! *)
(* ---------------------------------------------------------------------- *)

procedure attribue(totalrest:arraytot;niv,postn:integer;
                 var hrest,lrest:listbis; var h,l:real; var c,crest:complexe);
          (* dfinit h,l et c: la hauteur, la largeur et le coin superieur *)
          (* gauche attribue au compteur[niv]ime noeud fils pour celui de *)
          (* numero postn ainsi que hrest, lrest et crest restant pour les *)
          (* autres noeuds fils dans ce rectangle pere de numero postn *)
begin
     if lrest[niv] > hrest[niv] then begin
        h:=hrest[niv];
        if niv<>1 then if totalrest[round(posactu[niv-1]),niv]<epsilon then l:=0 else
        l:=lrest[niv]*m^[round(posactu[niv-1]),round(posactu[niv])]/totalrest[round(posactu[niv-1]),niv]
        else if totalrest[postn,1]<epsilon then l:=0 else
        l:=lrest[niv]*m^[postn,round(posactu[1])]/totalrest[postn,1];
        c:=crest;
        crest[1]:=crest[1]+l;
        lrest[niv]:=lrest[niv]-l;
     end else begin
         l:=lrest[niv];
         if niv<>1 then if totalrest[round(posactu[niv-1]),niv]<epsilon then h:=0 else
         h:=hrest[niv]*m^[round(posactu[niv-1]),round(posactu[niv])]/totalrest[round(posactu[niv-1]),niv]
         else if totalrest[postn,1]<epsilon then h:=0 else
         h:=hrest[niv]*m^[postn,round(posactu[1])]/totalrest[postn,1];
         c:=crest;
         crest[2]:=crest[2]+h;
         hrest[niv]:=hrest[niv]-h;
     end;
end;


                        (* .................. *)

procedure inittotal(var total:listtot);
          (* dfinit la valeur initiale de la liste total contenant la *)
          (* somme des liens de chaque noeud *)
var
   i,j,k:integer;
   ij:real;
begin
     k:=0;
     repeat
           k:=k+1;
           total[k]:=0;
     until k=n;
     i:=0;
     repeat
           i:=i+1;
           j:=0;
           ij:=0;
           repeat
                 j:=j+1;
                 if (i <> j) or (i=j)
                 then ij:=ij+m^[i,j];
           until j=n;
           total[i]:=ij;
     until i=n;
end;


                        (* ................. *)

procedure drawrect(a,b,h,l:real);
var
   r:array[1..4] of PointType;
   p1,p2,p3,p4:PointType;
begin
     p1.X:=round(a);
     p1.Y:=round(b);
     p2.X:=round(a+l);
     p2.Y:=round(b);
     p3.X:=round(a+l);
     p3.Y:=round(b+h);
     p4.X:=round(a);
     p4.Y:=round(b+h);
     r[1]:=p1;
     r[2]:=p2;
     r[3]:=p3;
     r[4]:=p4;
     (* drawpoly(4,((a,b),(a+l,b),(a+l,b+h),(a,b+h))) *)
     fillpoly(4,r);
end;

                        (* ............... *)

procedure rectangle(niv,postn:integer;c:complexe;h,l:real);
          (* trace le rectangle de numero classe^[postn,compteur[niv]] *)
          (* de coin superieur gauche c de hauteur h de argeur l *)
begin
     if niv<>1 then brut[round(c[1]*(taille-1)/hauteur+1),round(c[2]*(taille-1)/largeur+1)]:=round(posactu[niv]);
     setcolor(GetMaxColor);
end;

                        (* ............. *)

function same:boolean;
var
   bool:boolean;
   k:integer;
begin
     bool:=(true);
     for k:=1 to profndr-1
         do if compteur[k]=n+1 then bool:=(bool)and(true) else bool:=(false);
     same:=bool;
end;

                        (* ................ *)

procedure mainfract(postn:integer;total:listtot);
var
   l,h:real;
   hrest,lrest:listbis;
   i,j,k,niv:integer;
   coinre,coinim:listbis;
   c,crest:complexe;
   totalrest:arraytot;
begin
     niv:=1;
     clearviewport;
     for i:=1 to n do for j:=1 to profndr do totalrest[i,j]:=total[i];
     h:=hauteur;
     for k:=1 to profndr do hrest[k]:=h;
     l:=largeur;
     for k:=1 to profndr do lrest[k]:=l;
     for k:=1 to profndr do coinre[k]:=0;
     for k:=1 to profndr do coinim[k]:=0;
     for k:=1 to profndr do compteur[k]:=1;
     compteur[profndr]:=n+1;
     for k:=1 to profndr do posactu[k]:=postn;
     for i:=1 to taille do
         for j:=1 to taille do
             brut[i,j]:=0;

(***************** Ici commence la grande boucle fractale *******************)

     repeat
           if (niv<profndr) and (compteur[niv]<n+1) then begin
              if niv<>1 then
              posactu[niv]:=classe^[round(posactu[niv-1]),round(compteur[niv])]
              else posactu[1]:=round(classe^[postn,round(compteur[niv])]);
              crest[1]:=coinre[niv];
              crest[2]:=coinim[niv];
              attribue(totalrest,niv,postn,hrest,lrest,h,l,c,crest);
              coinre[niv]:=crest[1];
              coinim[niv]:=crest[2];
              if niv<>1 then
              totalrest[round(posactu[niv-1]),niv]:=totalrest[round(posactu[niv-1]),niv]
                                                    -m^[round(posactu[niv-1]),round(posactu[niv])]
                                    (* posactu[niv-1] est le numero du pere *)
              else                  (* et posactu[niv] celui du fils *)
              totalrest[postn,1]:=totalrest[postn,1]-m^[postn,round(posactu[1])];
              compteur[niv]:=compteur[niv]+1;
              if (h>pxl) and (l>pxl) then begin
                 rectangle(niv,postn,c,h,l);        (* dessine le rect fils *)
                 hrest[niv+1]:=h;
                 lrest[niv+1]:=l;
                 coinre[niv+1]:=c[1];
                 coinim[niv+1]:=c[2];
                 niv:=niv+1;
                 compteur[niv]:=1;
                 totalrest[round(posactu[niv-1]),niv]:=total[round(posactu[niv-1])];
              end else for i:=niv+1 to profndr do compteur[i]:=n+1;
           end else begin if niv=profndr then begin
                    niv:=niv-1;
               end else begin
                   repeat niv:=niv-1;
                   until compteur[niv]<>n+1;
               end;
           end;
     until same;
end;

                        (* ................. *)

procedure clearmoica;
begin
     setcolor(0);
     setfillstyle(1,0);
     FillPoly(SizeOf(rect) div SizeOf(PointType), rect);
     setcolor(getmaxcolor);
end;

                        (* ................. *)

procedure dessin(matdes:tablo;numero:integer;c:real);
var
   i,j,k,ll,hh,ek,col,p,coul,fil:integer;
   h1,h2,a0,a1,a2,a3,dx,dy:real;
   tri,tri1:triangle;
begin
     p:=5;
     coul:=0;
     c:=c/sqrt(n);
   dx:=(numero-1)mod(3)*200+20;
   dy:=int((numero-1)/3)*160+150;
   setcolor(5);
   col:=8;
   fil:=0;
   k:=p;
   ek:=round(exp(p*ln(2)));
   ll:=round(taille/ek);
   hh:=round(taille/ek);
   for j:=ek-1 downto 1 do begin
       a1:=matdes[1,taille+1-hh*(j+1)];
       a2:=matdes[1,taille+1-hh*j];
       tri[3]:=round(dx+(j+1)*hh*1.5*c);
       tri[4]:=round(dy-(j+1)*hh*2.6*c-a1);
       for i:=1 to ek-1 do begin
           a0:=a1;
            a3:=a2;
            a1:=matdes[ll*(i+1),taille+1-hh*(j+1)];
            a2:=matdes[ll*(i+1),taille+1-hh*j];
            tri[1]:=tri[3];
            tri[2]:=tri[4];
            tri[3]:=round(dx+ll*(i+1)*3*c+(j+1)*hh*1.5*c);
            tri[4]:=round(dy-(j+1)*hh*2.6*c-a1);
            tri[5]:=round(dx+ll*(i+1)*3*c+j*hh*1.5*c);
            tri[6]:=round(dy-j*hh*2.6*c-a2);
            col:=(numero)mod(GetMaxColor);
            if numero=9 then col:=GetMaxColor;
            if col=0 then col:=GetMaxColor;
            setcolor(col);
            setfillstyle(1,coul);
            if fil=0 then fillpoly(3,tri) else drawpoly(3,tri);
            tri1[1]:=tri[1];
            tri1[2]:=tri[2];
            tri1[3]:=tri[5];
            tri1[4]:=tri[6];
            tri1[5]:=round(dx+ll*i*3*c+j*hh*1.5*c);
            tri1[6]:=round(dy-j*hh*2.6*c-a3);
            col:=GetMaxColor;
            setcolor(col);
            setfillstyle(1,coul);
            if fil=0 then fillpoly(3,tri1) else drawpoly(3,tri1);
            end;
       end;
end;

                        (* ................. *)

procedure extrait_lisse_divise_dessine_additionne(i:integer);
var
   k,l,kk,ll,kkbas,kkhaut,llbas,llhaut:integer;
   toto,xx,yy,xy:real;
   extrait,lis:tablo;
   extralait,lalis:tablaloptr;
begin
     new(extralait);
     new(lalis);
     toto:=0;
     for k:=1 to taille do
         for l:=1 to taille do
         begin
              extrait[k,l]:=0;
              lis[k,l]:=0;
         end;
     for k:=1 to 3*taille do
         for l:=1 to 3*taille do
         begin
             extralait^[k,l]:=0;
             lalis^[k,l]:=0;
         end;
     for k:=1 to taille do
         for l:=1 to taille do
             if brut[k,l]=i then extrait[k,l]:=1;
     for k:=1 to 3*taille do
         for l:=1 to 3*taille do
             case k of
             1..taille: case l of
                        1..taille: extralait^[k,l]:=extrait[taille+1-k,taille+1-l];
                        taille+1..taille*2: extralait^[k,l]:=extrait[taille+1-k,l-taille];
                        2*taille+1..3*taille: extralait^[k,l]:=extrait[taille+1-k,3*taille+1-l];
                        end;
             taille+1..2*taille: case l of
                        1..taille: extralait^[k,l]:=extrait[k-taille,taille+1-l];
                        taille+1..taille*2: extralait^[k,l]:=extrait[k-taille,l-taille];
                        2*taille+1..3*taille: extralait^[k,l]:=extrait[k-taille,3*taille+1-l];
                        end;
             2*taille+1..3*taille: case l of
                        1..taille: extralait^[k,l]:=extrait[3*taille+1-k,taille+1-l];
                        taille+1..taille*2: extralait^[k,l]:=extrait[3*taille+1-k,l-taille];
                        2*taille+1..3*taille: extralait^[k,l]:=extrait[3*taille+1-k,3*taille+1-l];
                        end;
             end;
     for k:=1 to 3*taille do
         for l:=1 to 3*taille do
         if extralait^[k,l]=1 then begin
            xx:=0;
            yy:=0;
            xy:=0;
            if k<round(taille/2)+1 then kkbas:=1 else kkbas:=k-round(taille/2);
            if l<round(taille/2)+1 then llbas:=1 else llbas:=l-round(taille/2);
            if k>3*taille-round(taille/2) then kkhaut:=3*taille else kkhaut:=k+round(taille/2);
            if l>3*taille-round(taille/2) then llhaut:=3*taille else llhaut:=l+round(taille/2);
            for kk:=kkbas to kkhaut do
                for ll:=llbas to llhaut do
                    if extralait^[kk,ll]=1 then begin
                       xx:=xx+sqr(kk-k)/(coeflis/sqr(3*taille)*(sqr(kk-k)+sqr(ll-l))+1);
                       yy:=yy+sqr(ll-l)/(coeflis/sqr(3*taille)*(sqr(kk-k)+sqr(ll-l))+1);
                       xy:=xy+(kk-k)*(ll-l)/(coeflis/sqr(3*taille)*(sqr(kk-k)+sqr(ll-l))+1);
                    end;
            for kk:=kkbas to kkhaut do
                for ll:=llbas to llhaut do
                    lalis^[kk,ll]:=lalis^[kk,ll]
                    +1/(coeflis/sqr(3*taille)*(xx*sqr(kk-k)-2*xy*abs((kk-k)*(ll-l))+yy*sqr(ll-l))+1);
         end;
     for k:=1 to taille do
         for l:=1 to taille do
             lis[k,l]:=lalis^[k+taille,l+taille];
     for k:=1 to taille do
         for l:=1 to taille do
             toto:=toto+lis[k,l];
     if toto<>0 then for k:=1 to taille do
                         for l:=1 to taille do
                             lis[k,l]:=lis[k,l]/toto*coefz;
     dessin(lis,i,3);
     for k:=1 to taille do
         for l:=1 to taille do
             final[k,l]:=final[k,l]+sqr(lis[k,l]);
     dispose(extralait);
     dispose(lalis);
end;

(* ----------------------------------------------------------------------- *)
(* !---------------------------------------------------------------------! *)
(* !!                     Corps du programme                            !! *)
(* !---------------------------------------------------------------------! *)
(* ----------------------------------------------------------------------- *)


var
   key:char;
   code,postn,gd,gm,i:integer;
   total:listtot;
   event:TEvent;
   posliste:liste;
   toto:real;
begin

(********************** Initialisation et niveau origine ********************)

     new(m);
     new(classe);
     editor;
     writeln(' Noeud origine : ');
     key:=readkey;
     val(key,postn,code);
     writeln(key);
     gd:=detect;
     initgraph(gd, gm, ' ');
     writeln(graphErrorMsg(graphResult));
     if graphResult <> grOk then halt(1);
     inittotal(total);
     mainfract(postn,total);
     compt:=0;
     for gd:=1 to taille do
         for gm:=1 to taille do
             final[gd,gm]:=0;
     for i:=1 to n do extrait_lisse_divise_dessine_additionne(i);
     toto:=0;
     for gm:=1 to taille do for gd:=1 to taille do toto:=toto+final[gd,gm];
     for gm:=1 to taille do for gd:=1 to taille do final[gd,gm]:=final[gd,gm]/toto*coefz;
     dessin(final,9,5);
     repeat until keypressed;
     closegraph;
     writeln(' termine pouet ');
end.

(* ----------------------------------------------------------------------- *)
(* !---------------------------------------------------------------------! *)
(* !!                         Fin finale                                !! *)
(* !---------------------------------------------------------------------! *)
(* ----------------------------------------------------------------------- *)