program fractalg;


(* ---------------------------------------------------------------------- *)
(* !                        Initialisation                              ! *)
(* ---------------------------------------------------------------------- *)


uses crt,graph,drivers,objects,editrect;

const
     epsilon=0.001;
     pxl=1;       (* degr de dfinition maximale *)
     pi=3.14159;     (* ! *)
(*     profmax=25;     (* longueur maximale des listes !!! n !!! *)
     hauteur=450;        (* hauteur de l'cran en pixels *)
     largeur=450;       (* largeur de l'cran en pixels *)
     rect: array[1..4] of PointType = ((X:  490; Y: 65 ),
   (X: 600; Y: 65), (X:600; Y: 70+profndr*20),(X: 490; Y: 110+profndr*20));

type
    listbis=array[1..profndr] of real;
    listtot=array[1..taillemax] of real;
    complexe=array[1..2] of real;
    arraytot=array[1..taillemax,1..profndr] of real;
(* ---------------------------------------------------------------------- *)
(* !                      Procdures et fonctions                       ! *)
(* ---------------------------------------------------------------------- *)


procedure attribue(totalrest:arraytot;niv,postn:integer;
                 var hrest,lrest:listbis; var h,l:real; var c,crest:complexe);
          (* dfinit h,l et c: la hauteur, la largeur et le coin superieur *)
          (* gauche attribue au compteur[niv]ime noeud fils pour celui de *)
          (* numero postn ainsi que hrest, lrest et crest restant pour les *)
          (* autres noeuds fils dans ce rectangle pere de numero postn *)
begin
     if lrest[niv] > hrest[niv] then begin
        h:=hrest[niv];
        if niv<>1 then if totalrest[round(posactu[niv-1]),niv]<epsilon then l:=0 else
        l:=lrest[niv]*m^[round(posactu[niv-1]),round(posactu[niv])]/totalrest[round(posactu[niv-1]),niv]
        else if totalrest[postn,1]<epsilon then l:=0 else
        l:=lrest[niv]*m^[postn,round(posactu[1])]/totalrest[postn,1];
        c:=crest;
        crest[1]:=crest[1]+l;
        lrest[niv]:=lrest[niv]-l;
     end else begin
         l:=lrest[niv];
         if niv<>1 then if totalrest[round(posactu[niv-1]),niv]<epsilon then h:=0 else
         h:=hrest[niv]*m^[round(posactu[niv-1]),round(posactu[niv])]/totalrest[round(posactu[niv-1]),niv]
         else if totalrest[postn,1]<epsilon then h:=0 else
         h:=hrest[niv]*m^[postn,round(posactu[1])]/totalrest[postn,1];
         c:=crest;
         crest[2]:=crest[2]+h;
         hrest[niv]:=hrest[niv]-h;
     end;
end;


                        (* .................. *)

procedure inittotal(var total:listtot);
          (* dfinit la valeur initiale de la liste total contenant la *)
          (* somme des liens de chaque noeud *)
var
   i,j,k:integer;
   ij:real;
begin
     k:=0;
     repeat
           k:=k+1;
           total[k]:=0;
     until k=n;
     i:=0;
     repeat
           i:=i+1;
           j:=0;
           ij:=0;
           repeat
                 j:=j+1;
                 if (i <> j) or (i=j)
                 then ij:=ij+m^[i,j];
           until j=n;
           total[i]:=ij;
     until i=n;
end;


                        (* ................. *)

procedure drawrect(a,b,h,l:real);
var
   r:array[1..4] of PointType;
   p1,p2,p3,p4:PointType;
begin
     p1.X:=round(a);
     p1.Y:=round(b);
     p2.X:=round(a+l);
     p2.Y:=round(b);
     p3.X:=round(a+l);
     p3.Y:=round(b+h);
     p4.X:=round(a);
     p4.Y:=round(b+h);
     r[1]:=p1;
     r[2]:=p2;
     r[3]:=p3;
     r[4]:=p4;
     (* drawpoly(4,((a,b),(a+l,b),(a+l,b+h),(a,b+h))) *)
     fillpoly(4,r);
end;


                        (* ............... *)

procedure rectangle(niv,postn:integer;c:complexe;h,l:real);
          (* trace le rectangle de numero classe^[postn,compteur[niv]] *)
          (* de coin superieur gauche c de hauteur h de argeur l *)
begin
     if niv<>1 then begin
        setfillstyle((round(posactu[niv]+1))mod(12)
             ,(round(posactu[niv]+1))mod(GetMaxColor));
        setcolor((round(posactu[niv]+1))mod(GetMaxColor));
        drawrect(c[1],c[2],h,l);
     end else begin
         setfillstyle((round(posactu[1]+1))mod(12),(round(posactu[1]+1))mod(GetMaxColor));
         setcolor((round(posactu[1]+1))mod(GetMaxColor));
         drawrect(c[1],c[2],h,l);
     end;
     setcolor(GetMaxColor);
     (* if (h>7) and (l>8*length(noms[round(posactu[niv])]))
     then *)
     if (l>=h) and (h>7) and (l*(niv+3)/(2*niv+4)>7*length(noms[round(posactu[niv])]))
     then outtextxy(round(c[1]+l*(niv+3)/(2*niv+4)-8*length(noms[round(posactu[niv])])/2),round(c[2]+h/2-3)
                    ,noms[round(posactu[niv])]);
     if (h>l) and (h*(niv+3)/(2*niv+4)>7)and (l>8*length(noms[round(posactu[niv])]))
     then outtextxy(round(c[1]+l/2-8*length(noms[round(posactu[niv])])/2),round(c[2]+h*(niv+3)/(2*niv+4)-3)
                    ,noms[round(posactu[niv])]);
end;

                        (* ............. *)

function same:boolean;
var
   bool:boolean;
   k:integer;
begin
     bool:=(true);
     for k:=1 to profndr-1
         do if compteur[k]=n+1 then bool:=(bool)and(true) else bool:=(false);
     same:=bool;
end;

                        (* ................ *)

(* procedure quelsecteur(total:listtot;a,b,postn:integer; var posliste:liste);
var
   x,y,l,alpha,alphalast,alphapos,h0:real;
   i,postnlast,j:integer;
begin
     x:=a;
     y:=b;
     h0:=27.5;
     for j:=1 to profndr do begin
         if j=1 then begin
                l:=0;
                x:=x-h0;
                y:=y-h0;
            end
            else begin
                 l:=sqr(m^[postnlast,postn])/total[postnlast]*2*pi;
                 x:=x-(h0-h(l,h0))*cos(alphapos+l/2);
                 y:=y-(h0-h(l,h0))*sin(alphapos+l/2);
            end;
         if x=0 then x:=0.0000001;
         l:=arctan(y/x);
         if x<0 then l:=pi+l;
         if l<0 then l:=l+2*pi;
         alphalast:=0;
         postnlast:=postn;
         for i:=1 to n do begin
                           if i<>postn then begin
                                                    alpha:=alphalast+sqr(m^[postn,i])/total[postn]*2*pi;
                                                    if (l>alphalast) and (l<alpha) then begin
                                                                         postn:=i; i:=n;
                                                                         alphapos:=alphalast;
                                                    end;
                                                    alphalast:=alpha;
                           end;
                      end;
         posliste[j]:=postn;
     end;
end;

                        (* ............... *)

procedure mainfract(postn:integer;total:listtot);
var
   l,h:real;
   hrest,lrest:listbis;
   i,j,k,niv:integer;
   coinre,coinim:listbis;
   c,crest:complexe;
   totalrest:arraytot;
begin
     niv:=1;
     clearviewport;
     setfillstyle((postn+1)mod(12),(postn+1)mod(GetMaxColor));
     setcolor((postn+1)mod(GetMaxColor));
     for i:=1 to n do for j:=1 to profndr do totalrest[i,j]:=total[i];
     h:=round(hauteur/2);
     for k:=1 to profndr do hrest[k]:=h;
     l:=largeur;
     for k:=1 to profndr do lrest[k]:=l;
     for k:=1 to profndr do coinre[k]:=0;
     for k:=1 to profndr do coinim[k]:=0;
     for k:=1 to profndr do compteur[k]:=1;
     compteur[profndr]:=n+1;
     for k:=1 to profndr do posactu[k]:=postn;
     drawrect(0,0,hauteur,largeur);
     setcolor(GetMaxColor);
     outtextxy(round(l/2-7*length(noms[postn])/2),round(3*h/2-3),noms[postn]);

(***************** Ici commence la grande boucle fractale *******************)

     repeat
           if (niv<profndr) and (compteur[niv]<n+1) then begin
              if niv<>1 then
              posactu[niv]:=classe^[round(posactu[niv-1]),round(compteur[niv])]
              else posactu[1]:=round(classe^[postn,round(compteur[niv])]);
              crest[1]:=coinre[niv];
              crest[2]:=coinim[niv];
              attribue(totalrest,niv,postn,hrest,lrest,h,l,c,crest);
              coinre[niv]:=crest[1];
              coinim[niv]:=crest[2];
              if niv<>1 then
              totalrest[round(posactu[niv-1]),niv]:=totalrest[round(posactu[niv-1]),niv]
                                                    -m^[round(posactu[niv-1]),round(posactu[niv])]
                                    (* posactu[niv-1] est le numero du pere *)
              else                  (* et posactu[niv] celui du fils *)
              totalrest[postn,1]:=totalrest[postn,1]-m^[postn,round(posactu[1])];
              (*if chouia=1 then begin
                 chouia:=0; *)
                 compteur[niv]:=compteur[niv]+1;
              (*end;    *)
              if (h>pxl) and (l>pxl) then begin
                 rectangle(niv,postn,c,h,l);        (* dessine le rect fils *)
                 hrest[niv+1]:=h;
                 lrest[niv+1]:=l;
                 if h>l then hrest[niv+1]:=round(h/(niv+2)) else lrest[niv+1]:=round(l/(niv+2));
                 coinre[niv+1]:=c[1];
                 coinim[niv+1]:=c[2];
                 niv:=niv+1;
                 compteur[niv]:=1;
                 totalrest[round(posactu[niv-1]),niv]:=total[round(posactu[niv-1])];
              end else for i:=niv+1 to profndr do compteur[i]:=n+1;
           end else begin if niv=profndr then begin
                    (* chouia:=1; *)
                    niv:=niv-1;
               end else begin
                   repeat niv:=niv-1;
                   until compteur[niv]<>n+1;
                   (* chouia:=1; *)
               end;
           end;
     until same;
end;

                        (* ................. *)

procedure clearmoica;
begin
     setcolor(0);
     setfillstyle(1,0);
     FillPoly(SizeOf(rect) div SizeOf(PointType), rect);
     setcolor(getmaxcolor);
end;

(* ----------------------------------------------------------------------- *)
(* !---------------------------------------------------------------------! *)
(* !!                     Corps du programme                            !! *)
(* !---------------------------------------------------------------------! *)
(* ----------------------------------------------------------------------- *)


var
   key:char;
   code,postn,gd,gm,i:integer;
   total:listtot;
   event:TEvent;
   posliste:liste;
begin

(********************** Initialisation et niveau origine ********************)

     new(m);
     new(classe);
     editor;
     writeln(' Noeud origine : ');
     key:=readkey;
     val(key,postn,code);
     writeln(key);
     gd:=detect;
     initgraph(gd, gm, ' ');
     writeln(graphErrorMsg(graphResult));
     if graphResult <> grOk then halt(1);
     InitEvents;
     inittotal(total);
     (* repeat
           hidemouse; *)
           mainfract(postn,total);
           (* showmouse;
           setcolor(getmaxcolor);
           outtextxy(500,20,' POSITION :');
           outtextxy(500,50,noms[postn]);
           repeat
                 getmouseevent(event);
                 if event.what and evmousemove <> 0 then begin
                               quelsecteur(total,mousewhere.x,mousewhere.y,postn,posliste);
                               clearmoica;
                               for i:=1 to profndr do outtextxy(500,50+i*20,noms[round(posliste[i])]);
                 end;
           until (event.what and evMousedown <>0 ) and
(Event.Buttons and mbLeftButton <>0) or (keypressed);
           if not (keypressed) then begin
                                          quelsecteur(total,mousewhere.x,mousewhere.y,postn,posliste);
                                          postn:=round(posliste[1]);
                                    end;
     until keypressed; *)
     repeat until keypressed;
     closegraph;
end.

(* ----------------------------------------------------------------------- *)
(* !---------------------------------------------------------------------! *)
(* !!                         Fin finale                                !! *)
(* !---------------------------------------------------------------------! *)
(* ----------------------------------------------------------------------- *)