program fractalg;


(* ---------------------------------------------------------------------- *)
(* !                        Initialisation                              ! *)
(* ---------------------------------------------------------------------- *)


uses crt,graph,editgrap,drivers,objects;

const
     pxl=1/200;       (* degr de dfinition maximale *)
     pi=3.14159;     (* ! *)
     profndr=6;      (* niveau maximal de fractalisation *)
(*     profmax=25;     (* longueur maximale des listes !!! n !!! *)
     htr=450;        (* hauteur de l'cran en pixels *)
     lrgr=450;       (* largeur de l'cran en pixels *)
     rect: array[1..4] of PointType = ((X:  490; Y: 65 ),
   (X: 600; Y: 65), (X:600; Y: 70+profndr*20),(X: 490; Y: 110+profndr*20));

type
    liste=array[1..profndr] of integer;
    listbis=array[1..profndr] of real;
    listtot=array[1..taillemax] of real;
    complexe=array[1..2] of real;


(* ---------------------------------------------------------------------- *)
(* !                      Procdures et fonctions                       ! *)
(* ---------------------------------------------------------------------- *)


procedure angle(total:listtot;compteur:liste;niv,postn:integer; var theta:real);
          (* dfinit theta, angle attribu au noeud considr *)
var jerk,i:integer;
begin
     i:=compteur[niv];
     if niv > 1
     then jerk:=compteur[niv-1]
     else jerk:=postn;
     if i<>jerk then theta:=sqr(m^[jerk,i])/total[jerk]*2*pi else theta:=0;
end;


                        (* .................. *)

function selftheta(compteur:liste;niv,postn:integer;total:listtot):real;
         (* angle caractristique du noeud considr *)
var
   i,k:integer;
   tot:real;
begin
     k:=0;
     tot:=0;
     if niv=0
     then i:=postn
     else i:=compteur[niv];
     repeat
           k:=k+1;
           if k<>i then tot:=tot+sqr(m^[k,i]);
     until ((k=postn)and(niv=0))or((niv<>0)and(k=compteur[niv]));
     selftheta:=tot/total[i]*2*pi;
end;


                        (* .................. *)

procedure inittotal(var total:listtot);
          (* dfinit la valeur initiale de la liste total contenant la *)
          (* somme des liens de chaque noeud *)
var
   i,j,k:integer;
   ij:real;
begin
     k:=0;
     repeat
           k:=k+1;
           total[k]:=0;
     until k=n;
     i:=0;
     repeat
           i:=i+1;
           j:=0;
           ij:=0;
           repeat
                 j:=j+1;
                 if i <> j
                 then ij:=ij+sqr(m^[i,j]);
           until j=n;
           total[i]:=ij;
     until i=n;
end;


                        (* ................. *)

function rayon(theta,r0:real):real;
         (* rayon du sous-cercle inscrit dans le secteur d'angle theta *)
         (* du cercle de rayon r0 *)
begin
     rayon:=r0/2/sqr(cos((pi-theta)/4));
end;

                        (* ............... *)

procedure circlus(a,b,r:real);
begin
     (* circle(round(lrgr/2*(1+a)),round(htr/2*(1+b)),round(r*htr/2)); *)
     fillellipse(round(lrgr/2*(1+a)),round(htr/2*(1+b)),round(r*htr/2),round(r*htr/2));
end;

                        (* ............... *)

procedure linus(a,b,c,d:real);
begin
     line(round(lrgr*(1+a)/2),round(htr*(1+b)/2),round(lrgr*(1+c)/2),round(htr*(1+d)/2));
end;

                        (* ............... *)

procedure cercle(theta0,theta,r0:real;c0:complexe;compteur:liste;niv:integer;total:listtot);
          (* trace le cercle inscrit dans le secteur d'angle theta, *)
          (* commenant  theta0, dans le cercle de rayon r0 *)
var
   c:complexe;
   r:real;
begin
     c[1]:=cos(theta0+theta/2)*rayon(theta,r0)+c0[1];
     c[2]:=sin(theta0+theta/2)*rayon(theta,r0)+c0[2];
     r:=r0-rayon(theta,r0);
     setfillstyle((compteur[niv]+1)mod(12),(compteur[niv]+1)mod(GetMaxColor));
     setcolor((compteur[niv]+1)mod(GetMaxColor));
     circlus(c[1],c[2],r);
     (* linus(c[1],c[2],c[1]+r*cos(selftheta(compteur,niv,postn,total,m))
                         ,c[2]+r*sin(selftheta(compteur,niv,postn,total,m))); *)
     (* linus(c[1],c[2],c[1]+r,c[2]); *)
end;

                        (* ............. *)

function same(compteur:liste):boolean;
var
   bool:boolean;
   k:integer;
begin
     bool:=(true);
     for k:=1 to profndr
         do if compteur[k]=n then bool:=(bool)and(true) else bool:=(false);
     same:=bool;
end;

                        (* ................ *)

procedure quelsecteur(total:listtot;a,b,postn:integer; var posliste:liste);
var
   x,y,theta,alpha,alphalast,alphapos,r0:real;
   i,postnlast,j:integer;
begin
     x:=a;
     y:=b;
     r0:=27.5;
     for j:=1 to profndr do begin
         if j=1 then begin
                theta:=0;
                x:=x-r0;
                y:=y-r0;
            end
            else begin
                 theta:=sqr(m^[postnlast,postn])/total[postnlast]*2*pi;
                 x:=x-(r0-rayon(theta,r0))*cos(alphapos+theta/2);
                 y:=y-(r0-rayon(theta,r0))*sin(alphapos+theta/2);
            end;
         if x=0 then x:=0.0000001;
         theta:=arctan(y/x);
         if x<0 then theta:=pi+theta;
         if theta<0 then theta:=theta+2*pi;
         alphalast:=0;
         postnlast:=postn;
         for i:=1 to n do begin
                           if i<>postn then begin
                                                    alpha:=alphalast+sqr(m^[postn,i])/total[postn]*2*pi;
                                                    if (theta>alphalast) and (theta<alpha) then begin
                                                                         postn:=i; i:=n;
                                                                         alphapos:=alphalast;
                                                    end;
                                                    alphalast:=alpha;
                           end;
                      end;
         posliste[j]:=postn;
     end;
end;

                        (* ............... *)

procedure mainfract(postn:integer;total:listtot);
var
   chouia,r0,theta0,theta:real;
   k,niv:integer;
   compteur:liste;
   atet,ctrere,ctreim,rn:listbis;
   c0,c:complexe;
begin
     clearviewport;
     setfillstyle((postn+1)mod(12),(postn+1)mod(GetMaxColor));
     setcolor((postn+1)mod(GetMaxColor));
     chouia:=0;
     theta:=0;
     k:=0;
     repeat
           k:=k+1;
           compteur[k]:=0;
     until k=profndr;
               (* liste ... des numros des ... secteurs associs aux noeuds *)
               (* parents du noeud actuellement considr *)
     k:=0;
     repeat
           k:=k+1;
           atet[k]:=0;
     until k=profndr;
               (* ... des angles respectifs des ... *)
     ctrere:=atet;
               (* ... des parties relles des centres des ... *)
     ctreim:=ctrere;
               (* ... des parties imaginaires des centres des ... *)
     k:=0;
     repeat
           k:=k+1;
           rn[k]:=1;
     until k=profndr;
               (* ... des rayons des cercles inscrits dans les ... *)
     circlus(0,0,1);
               (* cercle origine *)
     niv:=0;

     (* linus(0,0,cos(selftheta(compteur,niv,postn,total,m)),sin(selftheta(compteur,niv,postn,total,m))); *)

(***************** Ici commence la grande boucle fractale *******************)

     repeat

           if niv <> 0  (* si on ne commence pas  peine *)
           then begin
               if (compteur[niv]=n)and((niv=profndr)or(chouia=1))
               then       (* si il faut remonter d'un niveau au moins *)
                   begin
                        repeat niv:=niv-1;
                        until compteur[niv]<n;
                        compteur[niv+1]:=0;
                   end
               else       (* si on continue au moins vers le mme niveau *)
                   if (niv < profndr)and(chouia=0)  (* et mme  un niveau infrieur *)
                   then begin
                             niv:=niv+1;
                             compteur[niv]:=0;
                             atet[niv]:=0;
                        end
               end
           else niv:=niv+1;  (* si on n'en est qu' l'origine *)

           compteur[niv]:=compteur[niv]+1;  (* secteur suivant au mme niv *)
           c0[1]:=ctrere[niv];
           c0[2]:=ctreim[niv];
           r0:=rn[niv];
           theta0:=atet[niv];
           angle(total,compteur,niv,postn,theta);
           if r0-rayon(theta,r0)>pxl
           then begin
                     cercle(theta0,theta,r0,c0,compteur,niv,total);
                     chouia:=0;
                end;
           theta0:=theta0+theta;
           atet[niv]:=theta0;
           if (niv<profndr)and(chouia=0)
           then begin
                     theta0:=theta0-theta;
                     c[1]:=cos(theta0+theta/2)*rayon(theta,r0)+c0[1];
                     c[2]:=sin(theta0+theta/2)*rayon(theta,r0)+c0[2];
                     theta0:=theta0+theta;
                     ctreim[niv+1]:=c[2];
                     ctrere[niv+1]:=c[1];
                     rn[niv+1]:=r0-rayon(theta,r0);
                end;
     until same(compteur);
end;

                        (* ................. *)

procedure clearmoica;
begin
     setcolor(0);
     setfillstyle(1,0);
     FillPoly(SizeOf(rect) div SizeOf(PointType), rect);
     setcolor(getmaxcolor);
end;

(* ----------------------------------------------------------------------- *)
(* !---------------------------------------------------------------------! *)
(* !!                     Corps du programme                            !! *)
(* !---------------------------------------------------------------------! *)
(* ----------------------------------------------------------------------- *)


var
   key:char;
   code,postn,gd,gm,i:integer;
   total:listtot;
   event:TEvent;
   posliste:liste;
begin

(********************** Initialisation et niveau origine ********************)

     new(m);
     editor;
     writeln(' Noeud origine : ');
     key:=readkey;
     val(key,postn,code);
     writeln(key);
     gd:=detect;
     initgraph(gd, gm, ' ');
     writeln(graphErrorMsg(graphResult));
     if graphResult <> grOk then halt(1);
     InitEvents;
     inittotal(total);
     repeat
           hidemouse;
           mainfract(postn,total);
           showmouse;
           setcolor(getmaxcolor);
           outtextxy(500,20,' POSITION :');
           outtextxy(500,50,noms[postn]);
           repeat
                 getmouseevent(event);
                 if event.what and evmousemove <> 0 then begin
                               quelsecteur(total,mousewhere.x,mousewhere.y,postn,posliste);
                               clearmoica;
                               for i:=1 to profndr do outtextxy(500,50+i*20,noms[posliste[i]]);
                 end;
           until (event.what and evMousedown <>0 ) and
(Event.Buttons and mbLeftButton <>0) or (keypressed);
           if not (keypressed) then begin
                                         quelsecteur(total,mousewhere.x,mousewhere.y,postn,posliste);
                                         postn:=posliste[1];
                                    end;
     until keypressed;
     closegraph;
end.

(* ----------------------------------------------------------------------- *)
(* !---------------------------------------------------------------------! *)
(* !!                         Fin finale                                !! *)
(* !---------------------------------------------------------------------! *)
(* ----------------------------------------------------------------------- *)